#!/bin/bash

VERSION_BIU=2.3.5
VERSION_GECODE=1.3.0
VERSION_CPSP=2.4.5

#########################################
echo " set up install pathes";
#########################################

export INSTALL_PATH=$HOME/CPSP-bundle-$VERSION_CPSP
export INSTALL_CPSP_COREDB=$HOME/CPSP_cores

#########################################
echo " make and install Gecode library";
#########################################

tar -xzf gecode-$VERSION_GECODE.tar.gz;
cd gecode-$VERSION_GECODE;
./configure --enable-static --disable-shared --disable-set-vars --disable-examples --prefix=$INSTALL_PATH;
make install;
cd ..;

#########################################
echo " make and install BIU library";
#########################################

tar -xzf biu-$VERSION_BIU.tar.gz;
cd biu-$VERSION_BIU;
./configure --prefix=$INSTALL_PATH;
make install;
cd ..;

#########################################
echo " make and install CPSP package";
#########################################

tar -xzf cpsp-$VERSION_CPSP.tar.gz;
cd cpsp-$VERSION_CPSP;
./configure --enable-static-linking --with-BIU=$INSTALL_PATH --with-gecode=$INSTALL_PATH --prefix=$INSTALL_PATH;
make install;
cd ..;

#########################################
echo " unzip Hcore data and install";
#########################################

mkdir -p $INSTALL_CPSP_COREDB;
tar -xzf CPSP_cores_cub.tar.gz;
mv -f Cubic $INSTALL_CPSP_COREDB;

#########################################
echo " run HPstruct example";
#########################################

$INSTALL_PATH/bin/HPstruct -seq=HPPPHPHHHPPHHHHPHPHHPHPH -lat=CUB -allbest -maxSol=20 -distMode=MOVE -distMin=6 -dbPath=$INSTALL_CPSP_COREDB -normalize

#########################################
echo " all done ...";
#########################################

